"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ADDING_NULLABLE_WITHOUT_OPTIONS = exports.NON_EXISTENT_VALUE_ON_OPTIONS = exports.MISSING_VALUE_ON_NON_NULLABLE = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MISSING_VALUE_ON_NON_NULLABLE = 0;
exports.MISSING_VALUE_ON_NON_NULLABLE = MISSING_VALUE_ON_NON_NULLABLE;
var NON_EXISTENT_VALUE_ON_OPTIONS = 1;
exports.NON_EXISTENT_VALUE_ON_OPTIONS = NON_EXISTENT_VALUE_ON_OPTIONS;
var ADDING_NULLABLE_WITHOUT_OPTIONS = 2;
exports.ADDING_NULLABLE_WITHOUT_OPTIONS = ADDING_NULLABLE_WITHOUT_OPTIONS;

var SelectError =
/*#__PURE__*/
function (_Error) {
  _inherits(SelectError, _Error);

  function SelectError(message) {
    var _this;

    var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : SelectError.MISSING_VALUE_ON_NON_NULLABLE;

    _classCallCheck(this, SelectError);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SelectError).call(this, message));
    _this.code = code;
    _this.name = 'SelectError';
    return _this;
  }

  _createClass(SelectError, null, [{
    key: "fromMissingValueOnNonNullable",
    value: function fromMissingValueOnNonNullable() {
      var message = 'Did not pass a value property to a non nullable Select component';
      return new SelectError(message, SelectError.MISSING_VALUE_ON_NON_NULLABLE);
    }
  }, {
    key: "fromAddingNullableWithoutOptions",
    value: function fromAddingNullableWithoutOptions() {
      var message = 'Cannot add nullable property without an options';
      return new SelectError(message, SelectError.ADDING_NULLABLE_WITHOUT_OPTIONS);
    }
  }, {
    key: "fromNonExistentValueOnOptions",
    value: function fromNonExistentValueOnOptions(value) {
      var message = "Invalid value ".concat(value, ", it does not exist as a value in any of the options.");
      return new SelectError(message, SelectError.NON_EXISTENT_VALUE_ON_OPTIONS);
    }
  }]);

  return SelectError;
}(_wrapNativeSuper(Error));

_defineProperty(SelectError, "MISSING_VALUE_ON_NON_NULLABLE", 0);

_defineProperty(SelectError, "NON_EXISTENT_VALUE_ON_OPTIONS", 1);

var _default = SelectError;
exports["default"] = _default;